using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Sales.CreditNote.Cqrs;

public record DeleteCreditNoteByIdCommand(string Id) : IRequest<bool>;

public class DeleteCreditNoteByIdHandler : IRequestHandler<DeleteCreditNoteByIdCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteCreditNoteByIdHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteCreditNoteByIdCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.CreditNote
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.CreditNote.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);
        return true;
    }
}